//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrDeepPink
#property indicator_color3  clrGold
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_minimum 0
#property indicator_maximum 1
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

enum enTimeFrames
{
   tf_cu  = 0,              // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mb1 = PERIOD_MN1,     // Monthly
   tf_cus = 12345678        // Custom time frame
};


extern enTimeFrames    TimeFrame             = tf_cu;    // Time frame
extern int             TimeFrameCustom       = 0;        // Custom time frame to use (if custom time frame used)
extern int             Tenkan                = 9;        // Tenkan Period
extern int             Kijun                 = 26;       // Kijun Period
extern int             Senkou                = 52;       // Senkou Period
extern enPrices        BreakoutPrice         = pr_close; // Price to use
extern bool            alertsOn              = false;    // Tutn alerts on
extern bool            alertsOnCurrent       = true;     // Alerts on currnt (still opened) bar
extern bool            alertsMessage         = true;     // Alerts should show pop-up message
extern bool            alertsSound           = false;    // Alerts should play alert sound
extern bool            alertsNotify          = false;    // Alerts should send push notification
extern bool            alertsEmail           = false;    // Alerts should send email
extern bool            verticalLinesVisible  = false;             // Show Lines
extern bool            linesOnNewest         = false;             // Arrows drawn on newest bar of higher time frame bar?
extern string          verticalLinesID       = "KUMO Lines";      // lines ID
extern color           verticalLinesUpColor  = clrDeepSkyBlue;    // lines up color 
extern color           verticalLinesDnColor  = clrPaleVioletRed;  // lines down color
extern color           verticalLinesNuColor  = clrGold;           // lines neutral color
extern ENUM_LINE_STYLE verticalLinesStyle    = STYLE_DOT;         // lines style
extern int             verticalLinesWidth    = 0;                 // lines width

//
//
//
//
//

double Tenkan_Buffer[];
double Kijun_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
double UpH[];
double DnH[]; 
double NuH[];   
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_HISTOGRAM);   
      SetIndexBuffer(2,NuH); SetIndexStyle(2,DRAW_HISTOGRAM);                          
      SetIndexBuffer(3,SpanA_Buffer);  
      SetIndexBuffer(4,SpanB_Buffer);  
      SetIndexBuffer(5,Tenkan_Buffer);                     
      SetIndexBuffer(6,Kijun_Buffer);   
      SetIndexBuffer(7,trend); 
     
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99; 
      if (TimeFrameCustom==0) TimeFrameCustom = MathMax(TimeFrameCustom,_Period);
      if (TimeFrame!=tf_cus)
            TimeFrame = MathMax(TimeFrame,_Period);
      else  TimeFrame = (enTimeFrames)TimeFrameCustom;
        
      SetIndexShift(3,Kijun * TimeFrame/Period());  
      SetIndexShift(4,Kijun * TimeFrame/Period());  
      SetIndexShift(5,Kijun * TimeFrame/Period());
      SetIndexShift(6,Kijun * TimeFrame/Period());        
     
      //
      //
      //
      //
      //
     
     IndicatorShortName(timeFrameToString(TimeFrame)+"  Kumo Breakout Histo");
     
return(0);
}  
int deinit() 
{ 
   string tlookFor       = verticalLinesID+":";
   int    tlookForLength = StringLen(tlookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,tlookForLength) == tlookFor) ObjectDelete(objectName);
   }

return(0); 
}  
  
//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int i,k,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { UpH[0] = MathMin(limit+1,Bars-1); return(0); }
   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
     for(i=limit; i>=0; i--)
     {
        double price  = getPrice(BreakoutPrice,Open,Close,High,Low,i);
        double thi    = iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i);
        double tlo    = iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i);
        double tprice = 0;
        if (i >= Bars - Tenkan) continue;
        for (k = 1; k < Tenkan; k++)
        {
           tprice = iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i+k); if(thi < tprice) thi = tprice;
           tprice = iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i+k);  if(tlo > tprice) tlo = tprice;
        }
       
        if ((thi+tlo) > 0.0) 
             Tenkan_Buffer[i] = (thi + tlo)*0.5; 
        else Tenkan_Buffer[i] = 0;
       
       //
       //
       //
       //
       //
       
       double khi    = iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i);
       double klo    = iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i);
       double kprice = 0;
       if  (i >= Bars - Kijun) continue;
       for (k = 1; k < Kijun; k++)
       {
          kprice = iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i+k); if(khi < kprice) khi  = kprice;
          kprice = iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i+k);  if(klo > kprice) klo  = kprice;
       }
        
       if ((khi+klo) > 0.0) 
            Kijun_Buffer[i] = (khi + klo)*0.5; 
       else Kijun_Buffer[i] = 0;
            SpanA_Buffer[i] = (Kijun_Buffer[i] + Tenkan_Buffer[i])/2;
            
       //
       //
       //
       //
       //
        
       double shi    = iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i);
       double slo    = iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i);
       double sprice = 0;
       if (i >= Bars - Senkou) continue;
       for (k = 1; k < Senkou; k++)
       {
          sprice = iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i+k); if(shi < sprice) shi = sprice;
          sprice = iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i+k);  if(slo > sprice) slo = sprice;
        }
        
        if ((shi+slo) > 0.0) 
             SpanB_Buffer[i] = (shi + slo)*0.5;  
        else SpanB_Buffer[i] = 0;
           
        UpH[i] = EMPTY_VALUE;
        DnH[i] = EMPTY_VALUE;
        NuH[i] = EMPTY_VALUE;
        if (i<Bars-1)
        {
           trend[i] = trend[i+1];
           if (price > MathMax(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun]))                                                                    trend[i] = 1; 
           if (price < MathMin(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun]))                                                                    trend[i] =-1; 
           if (price < MathMax(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun]) && price > MathMin(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun])) trend[i] = 0; 
           if (trend[i] == 1) UpH[i] = 1;
           if (trend[i] ==-1) DnH[i] = 1;
           if (trend[i] == 0) NuH[i] = 1;
         }
         
         //
         //
         //
         //
         //
         
         if (verticalLinesVisible)
         {
           string tlookFor = verticalLinesID+":"+(string)Time[i]; ObjectDelete(tlookFor);  
           if (trend[i] != trend[i+1])
           {
              if (trend[i] == 1) drawLine(i,verticalLinesUpColor);
              if (trend[i] ==-1) drawLine(i,verticalLinesDnColor);
              if (trend[i] == 0) drawLine(i,verticalLinesNuColor);
           }
         }    
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
        if (trend[whichBar] != trend[whichBar+1])
        {
         if (trend[whichBar] == 1)                          doAlert(whichBar,"breaking cloud up");
         if (trend[whichBar] ==-1)                          doAlert(whichBar,"breaking cloud down");
         if (trend[whichBar] == 0 && trend[whichBar+1]== 1) doAlert(whichBar,"back into cloud from up, now neutral");
         if (trend[whichBar] ==-0 && trend[whichBar+1]==-1) doAlert(whichBar,"back into cloud from down, now neutral");
        }         
      }
      
      return(0);
      }
      
      //
      //
      //
      //
      //
   
      limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,TimeFrame,Time[i]);
            UpH[i] = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,Tenkan,Kijun,Senkou,BreakoutPrice,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,verticalLinesVisible,linesOnNewest,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesNuColor,verticalLinesStyle,verticalLinesWidth,0,y);
            DnH[i] = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,Tenkan,Kijun,Senkou,BreakoutPrice,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,verticalLinesVisible,linesOnNewest,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesNuColor,verticalLinesStyle,verticalLinesWidth,1,y);
            NuH[i] = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,Tenkan,Kijun,Senkou,BreakoutPrice,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,verticalLinesVisible,linesOnNewest,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesNuColor,verticalLinesStyle,verticalLinesWidth,2,y);
      }
return(0);         
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," AOAC ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " kumo breakout "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//
//
//
//
//

void drawLine(int i,color theColor)
{
      string name = verticalLinesID+":"+(string)Time[i];
   
      //
      //
      //
      //
      //
         
      datetime time = Time[i]; if (linesOnNewest) time += _Period*60-1;    
      ObjectCreate(name,OBJ_VLINE,0,time,0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}


               
     
  
  